
import java.io.*;
import mpi.*;

class MPI_single {

  static final int  PINGPONGS = 16;
  //static final int  PINGPONGS = 2000;
  static final int  SAMPLES   = 16;
  static final int  LOG2N_MAX = 19;
  //static final int  LOG2N_MAX = 20; // <-java.lang.OutOfMemoryError
  static final int  N_MAX     = ( 1 << (LOG2N_MAX-3) );


  //LARGE_INTEGER StartTime;
  //LARGE_INTEGER GetStartTime();
  //static void   InitTimer();
  //static double timer();
  //static void   table_top(), table_body();

  public static void main(String[] args) {
     
    //double     tf[SAMPLES + 1], t_call;
    double     tf[] = new double[SAMPLES + 1];
    double     t_call;
    int        i, j_pe, log2nbyte, nbyte, ns, n_pp, my_pe, npes;
    int        n_init, n_mess;
    //double     A[];
    //char       *Title ="Single Messages --- MPI";
    String     Title ="Single Messages --- MPICH_JAVA on Solaris";
    //FILE       *ifp;
    PrintStream pfout = null;
    Status     status;


    MPI.Init(args);

    my_pe = MPI.COMM_WORLD.Rank();
    npes  = MPI.COMM_WORLD.Size();

    ////StartTime = GetStartTime(); /* Get StartTime */


    tf[0] = MPI.Wtime();
    for (ns = 1; ns <= SAMPLES; ++ns) {
      tf[ns] = MPI.Wtime();
    }
    t_call = (tf[SAMPLES] - tf[0]) / SAMPLES;

    if(my_pe==0) System.out.println("\n t_call= "+t_call+" seconds");
    

    n_init = 2 * PINGPONGS;
    n_mess = 2 * PINGPONGS;    


    if (my_pe == 0) {
      //ifp = fopen("c:\\temp\\mpi_single.dat","w");
      try {
	FileOutputStream fout = new FileOutputStream("MPI_single_JAVA.dat");
	pfout = new PrintStream(fout);
      }
      catch(IOException ioe) {
	System.err.println("Error in FileOutput...."+ioe);
      }

      Table.table_top(npes, n_init, n_mess, SAMPLES, t_call, Title);
      //System.exit(1);
    }

    

    //    for (log2nbyte = 0; log2nbyte <= LOG2N_MAX; ++log2nbyte) {
    for (log2nbyte = 3; log2nbyte <= LOG2N_MAX; ++log2nbyte) {
      nbyte = ( 1 << log2nbyte );
      
      double A[] = new double[nbyte];
      //if ( (A  = (double *) malloc(nbyte * sizeof(double))) == NULL ) {
      //printf( "Insufficient memory available\n" );
      //exit(1);
      //}
      
      for (i = 0; i < nbyte; i++) {
	A[i] = (double) 1. / (i + 1);
      }
      
      
      for (j_pe = 1; j_pe <= npes-1; ++j_pe) {
	MPI.COMM_WORLD.Barrier();
	tf[0] = MPI.Wtime();
	for (ns = 0; ns < SAMPLES; ns++) {
	  for (n_pp = 0; n_pp < PINGPONGS; n_pp++) {
	    if (my_pe == j_pe) {
	      //printf("my PE = %d \n", my_pe);
	      //System.out.println("my PE = "+my_pe); 
	      //MPI.COMM_WORLD.Send(A, 0, nbyte, MPI.BYTE, 0, 10);
	      //status = MPI.COMM_WORLD.Recv(A, 0 ,nbyte, MPI.BYTE, 0, 20);
	      MPI.COMM_WORLD.Send(A, 0, nbyte/8, MPI.DOUBLE, 0, 10);
	      status = MPI.COMM_WORLD.Recv(A, 0 ,nbyte/8, MPI.DOUBLE, 0, 20);
	    }
	    if (my_pe == 0) {
	      //System.out.println("my PE = "+my_pe); 
	      //MPI_Recv(A,nbyte,MPI_BYTE,j_pe,10,MPI_COMM_WORLD,&status);
	      //MPI_Send(A,nbyte,MPI_BYTE,j_pe,20,MPI_COMM_WORLD);
	      //status = MPI.COMM_WORLD.Recv(A, 0 ,nbyte, MPI.BYTE, j_pe, 10);
	      //MPI.COMM_WORLD.Send(A, 0, nbyte, MPI.BYTE, j_pe, 20);
	      status = MPI.COMM_WORLD.Recv(A, 0 ,nbyte/8, MPI.DOUBLE, j_pe, 10);
	      MPI.COMM_WORLD.Send(A, 0, nbyte/8, MPI.DOUBLE, j_pe, 20);
	    }
	  }
	  tf[ns+1] = MPI.Wtime();
	  //System.out.println("tf["+(ns+1)+"]= "+tf[ns+1]);
	}
	if (my_pe == 0)
	  Table.table_body(j_pe, nbyte, n_init, n_mess,
			   SAMPLES, t_call, tf, pfout);
      }
      
      
    }
    

    System.out.println("\n"+MPI.Get_processor_name()+": Finished");
    //if(my_pe == 0) System.out.println("\n Finished");
    MPI.Finalize();    
    //return 0;
  }

}
  

